package net.rmi.rjs.pk.LusCs;

import gui.ClosableJFrame;
import gui.JInfoFrame;
import gui.layouts.VerticalFlowLayout;
import gui.layouts.VerticalLayout;
import net.multicast.McastUtil;

import javax.swing.*;
import java.awt.*;
import java.io.IOException;
import java.net.InetAddress;


public class LusCr320Rcvr extends Thread {
    private McastUtil mcu;
    public JInfoFrame jif;
    public InetAddress lusIp;
    public InetAddress ip;
    public static String IP = null;
    private String mflops = null;
    private CsRecords csRecords;
    ClosableJFrame csRecordFrame = new ClosableJFrame();
    JPanel csRecordPanels = new JPanel();


    public LusCr320Rcvr(McastUtil mcu, JInfoFrame jif, CsRecords csRecords) {
        this.jif = jif;
        this.mcu = mcu;
        this.csRecords = csRecords;
        start();                // start calls run
        initRecords();
    }

    public void run() {
        try {
            while (true) {
                processBytes();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void processBytes() throws IOException {

        BenchMarkBean bmb = BenchMarkBean.create(mcu.getBytes());
        ip = mcu.getReceiveAddress();
        lusIp = mcu.getSendAddress();
        CsRecord csr = new CsRecord();
        csr.setBmb(bmb);
        csr.setIpAddress(ip);
        csRecords.add(csr);
        jif.println(csr + "");
        addRecord(csr);

    }

    private void addRecord(CsRecord csr) {
        csRecordPanels.add(new CsRecordPanel(csr));
    }

    private void initRecords() {

        Container c = csRecordFrame.getContentPane();
        csRecordPanels.setLayout(new VerticalLayout());

        CsRecord csra[] = csRecords.getRecords();
        for (int i = 0; i < csra.length; i++) {
            csRecordPanels.add(new CsRecordPanel(csra[i]));
        }
        csRecordPanels.add(new ButtonControlPanel(csRecords));
        JScrollPane jsp = new JScrollPane(csRecordPanels){
            public Dimension getPreferredSize(){
                Dimension d = super.getPreferredSize();
                if (d.height < 400) return new Dimension(400,400);
                return d;
            }
        };
        c.add(jsp);
        csRecordFrame.pack();
        csRecordFrame.setVisible(true);
    }


    public InetAddress getSendAddress() {
        return mcu.getSendAddress();
    }

    public static String getLusIp() throws IOException {
        System.out.println(
                "from lus my ip " +
                        InetAddress.getLocalHost().getHostAddress().toString());
        return InetAddress.getLocalHost().getHostAddress().toString();
    }


}

